"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var URI = require("urijs");
var api_1 = require("./api");
var DefaultService = /** @class */ (function () {
    function DefaultService(basePath, token) {
        this.token = token;
        this.basePath = basePath;
    }
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param force Whether to bypass trash and force deletion.
    */
    DefaultService.prototype.deleteWpV2BlocksById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the term.
     * @param force Required to be true, as terms do not support trashing.
    */
    DefaultService.prototype.deleteWpV2CategoriesById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param force Whether to bypass trash and force deletion.
     * @param password The password for the parent post of the comment (if the post is password protected).
    */
    DefaultService.prototype.deleteWpV2CommentsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        if (opts.password !== undefined && opts.password !== null) {
                            uri.addQuery('password', opts.password);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param force Whether to bypass trash and force deletion.
    */
    DefaultService.prototype.deleteWpV2MediaById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param force Whether to bypass trash and force deletion.
    */
    DefaultService.prototype.deleteWpV2PagesById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param parent
     * @param id
     * @param parent2 The ID for the parent of the object.
     * @param id2 Unique identifier for the object.
     * @param force Required to be true, as revisions do not support trashing.
    */
    DefaultService.prototype.deleteWpV2PagesByParentRevisionsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent2 !== undefined && opts.parent2 !== null) {
                            uri.addQuery('parent', opts.parent2);
                        }
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param force Whether to bypass trash and force deletion.
    */
    DefaultService.prototype.deleteWpV2PostsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param parent
     * @param id
     * @param parent2 The ID for the parent of the object.
     * @param id2 Unique identifier for the object.
     * @param force Required to be true, as revisions do not support trashing.
    */
    DefaultService.prototype.deleteWpV2PostsByParentRevisionsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent2 !== undefined && opts.parent2 !== null) {
                            uri.addQuery('parent', opts.parent2);
                        }
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the term.
     * @param force Required to be true, as terms do not support trashing.
    */
    DefaultService.prototype.deleteWpV2TagsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param reassign Reassign the deleted user&#39;s posts and links to this user ID.
     * @param id2 Unique identifier for the user.
     * @param force Required to be true, as users do not support trashing.
    */
    DefaultService.prototype.deleteWpV2UsersById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        if (opts.reassign !== undefined && opts.reassign !== null) {
                            uri.addQuery('reassign', opts.reassign);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param reassign Reassign the deleted user&#39;s posts and links to this user ID.
     * @param force Required to be true, as users do not support trashing.
    */
    DefaultService.prototype.deleteWpV2UsersMe = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.force !== undefined && opts.force !== null) {
                            uri.addQuery('force', opts.force);
                        }
                        if (opts.reassign !== undefined && opts.reassign !== null) {
                            uri.addQuery('reassign', opts.reassign);
                        }
                        options = {
                            method: "delete",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
    */
    DefaultService.prototype.getMenusV1Locations = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
    */
    DefaultService.prototype.getMenusV1LocationsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
    */
    DefaultService.prototype.getMenusV1Menus = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
    */
    DefaultService.prototype.getMenusV1MenusById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param name
     * @param name2 Unique registered name for the block.
     * @param context Scope under which the request is made; determines fields present in response.
     * @param attributes Attributes for core/tag-cloud block
     * @param postId ID of the post context.
    */
    DefaultService.prototype.getWpV2BlockRendererByName = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.name2 !== undefined && opts.name2 !== null) {
                            uri.addQuery('name', opts.name2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.attributes !== undefined && opts.attributes !== null) {
                            uri.addQuery('attributes', opts.attributes);
                        }
                        if (opts.postId !== undefined && opts.postId !== null) {
                            uri.addQuery('post_id', opts.postId);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param after Limit response to posts published after a given ISO8601 compliant date.
     * @param before Limit response to posts published before a given ISO8601 compliant date.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param offset Offset the result set by a specific number of items.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by object attribute.
     * @param slug Limit result set to posts with one or more specific slugs.
     * @param status Limit result set to posts assigned one or more statuses.
    */
    DefaultService.prototype.getWpV2Blocks = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.after !== undefined && opts.after !== null) {
                            uri.addQuery('after', opts.after.toISOString());
                        }
                        if (opts.before !== undefined && opts.before !== null) {
                            uri.addQuery('before', opts.before.toISOString());
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.offset !== undefined && opts.offset !== null) {
                            uri.addQuery('offset', opts.offset);
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        if (opts.slug) {
                            opts.slug.forEach(function (element) {
                                uri.addQuery('slug', element);
                            });
                        }
                        if (opts.status) {
                            opts.status.forEach(function (element) {
                                uri.addQuery('status', element);
                            });
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param context Scope under which the request is made; determines fields present in response.
     * @param password The password for the post if it is password protected.
    */
    DefaultService.prototype.getWpV2BlocksById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.password !== undefined && opts.password !== null) {
                            uri.addQuery('password', opts.password);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param parent The ID for the parent of the object.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2BlocksByIdAutosaves = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent !== undefined && opts.parent !== null) {
                            uri.addQuery('parent', opts.parent);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param parent
     * @param id
     * @param parent2 The ID for the parent of the object.
     * @param id2 The ID for the object.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2BlocksByParentAutosavesById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent2 !== undefined && opts.parent2 !== null) {
                            uri.addQuery('parent', opts.parent2);
                        }
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by term attribute.
     * @param hideEmpty Whether to hide terms not assigned to any posts.
     * @param parent Limit result set to terms assigned to a specific parent.
     * @param post Limit result set to terms assigned to a specific post.
     * @param slug Limit result set to terms with one or more specific slugs.
    */
    DefaultService.prototype.getWpV2Categories = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        if (opts.hideEmpty !== undefined && opts.hideEmpty !== null) {
                            uri.addQuery('hide_empty', opts.hideEmpty);
                        }
                        if (opts.parent !== undefined && opts.parent !== null) {
                            uri.addQuery('parent', opts.parent);
                        }
                        if (opts.post !== undefined && opts.post !== null) {
                            uri.addQuery('post', opts.post);
                        }
                        if (opts.slug) {
                            opts.slug.forEach(function (element) {
                                uri.addQuery('slug', element);
                            });
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the term.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2CategoriesById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param after Limit response to comments published after a given ISO8601 compliant date.
     * @param author Limit result set to comments assigned to specific user IDs. Requires authorization.
     * @param authorExclude Ensure result set excludes comments assigned to specific user IDs. Requires authorization.
     * @param authorEmail Limit result set to that from a specific author email. Requires authorization.
     * @param before Limit response to comments published before a given ISO8601 compliant date.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param offset Offset the result set by a specific number of items.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by object attribute.
     * @param parent Limit result set to comments of specific parent IDs.
     * @param parentExclude Ensure result set excludes specific parent IDs.
     * @param post Limit result set to comments assigned to specific post IDs.
     * @param status Limit result set to comments assigned a specific status. Requires authorization.
     * @param type Limit result set to comments assigned a specific type. Requires authorization.
     * @param password The password for the post if it is password protected.
    */
    DefaultService.prototype.getWpV2Comments = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.after !== undefined && opts.after !== null) {
                            uri.addQuery('after', opts.after.toISOString());
                        }
                        if (opts.author) {
                            opts.author.forEach(function (element) {
                                uri.addQuery('author', element);
                            });
                        }
                        if (opts.authorExclude) {
                            opts.authorExclude.forEach(function (element) {
                                uri.addQuery('author_exclude', element);
                            });
                        }
                        if (opts.authorEmail !== undefined && opts.authorEmail !== null) {
                            uri.addQuery('author_email', opts.authorEmail);
                        }
                        if (opts.before !== undefined && opts.before !== null) {
                            uri.addQuery('before', opts.before.toISOString());
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.offset !== undefined && opts.offset !== null) {
                            uri.addQuery('offset', opts.offset);
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        if (opts.parent) {
                            opts.parent.forEach(function (element) {
                                uri.addQuery('parent', element);
                            });
                        }
                        if (opts.parentExclude) {
                            opts.parentExclude.forEach(function (element) {
                                uri.addQuery('parent_exclude', element);
                            });
                        }
                        if (opts.post) {
                            opts.post.forEach(function (element) {
                                uri.addQuery('post', element);
                            });
                        }
                        if (opts.status !== undefined && opts.status !== null) {
                            uri.addQuery('status', opts.status);
                        }
                        if (opts.type !== undefined && opts.type !== null) {
                            uri.addQuery('type', opts.type);
                        }
                        if (opts.password !== undefined && opts.password !== null) {
                            uri.addQuery('password', opts.password);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param context Scope under which the request is made; determines fields present in response.
     * @param password The password for the parent post of the comment (if the post is password protected).
    */
    DefaultService.prototype.getWpV2CommentsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.password !== undefined && opts.password !== null) {
                            uri.addQuery('password', opts.password);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param after Limit response to posts published after a given ISO8601 compliant date.
     * @param author Limit result set to posts assigned to specific authors.
     * @param authorExclude Ensure result set excludes posts assigned to specific authors.
     * @param before Limit response to posts published before a given ISO8601 compliant date.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param offset Offset the result set by a specific number of items.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by object attribute.
     * @param parent Limit result set to items with particular parent IDs.
     * @param parentExclude Limit result set to all items except those of a particular parent ID.
     * @param slug Limit result set to posts with one or more specific slugs.
     * @param status Limit result set to posts assigned one or more statuses.
     * @param mediaType Limit result set to attachments of a particular media type.
     * @param mimeType Limit result set to attachments of a particular MIME type.
    */
    DefaultService.prototype.getWpV2Media = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.after !== undefined && opts.after !== null) {
                            uri.addQuery('after', opts.after.toISOString());
                        }
                        if (opts.author) {
                            opts.author.forEach(function (element) {
                                uri.addQuery('author', element);
                            });
                        }
                        if (opts.authorExclude) {
                            opts.authorExclude.forEach(function (element) {
                                uri.addQuery('author_exclude', element);
                            });
                        }
                        if (opts.before !== undefined && opts.before !== null) {
                            uri.addQuery('before', opts.before.toISOString());
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.offset !== undefined && opts.offset !== null) {
                            uri.addQuery('offset', opts.offset);
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        if (opts.parent) {
                            opts.parent.forEach(function (element) {
                                uri.addQuery('parent', element);
                            });
                        }
                        if (opts.parentExclude) {
                            opts.parentExclude.forEach(function (element) {
                                uri.addQuery('parent_exclude', element);
                            });
                        }
                        if (opts.slug) {
                            opts.slug.forEach(function (element) {
                                uri.addQuery('slug', element);
                            });
                        }
                        if (opts.status) {
                            opts.status.forEach(function (element) {
                                uri.addQuery('status', element);
                            });
                        }
                        if (opts.mediaType !== undefined && opts.mediaType !== null) {
                            uri.addQuery('media_type', opts.mediaType);
                        }
                        if (opts.mimeType !== undefined && opts.mimeType !== null) {
                            uri.addQuery('mime_type', opts.mimeType);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2MediaById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param after Limit response to posts published after a given ISO8601 compliant date.
     * @param author Limit result set to posts assigned to specific authors.
     * @param authorExclude Ensure result set excludes posts assigned to specific authors.
     * @param before Limit response to posts published before a given ISO8601 compliant date.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param menuOrder Limit result set to posts with a specific menu_order value.
     * @param offset Offset the result set by a specific number of items.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by object attribute.
     * @param parent Limit result set to items with particular parent IDs.
     * @param parentExclude Limit result set to all items except those of a particular parent ID.
     * @param slug Limit result set to posts with one or more specific slugs.
     * @param status Limit result set to posts assigned one or more statuses.
    */
    DefaultService.prototype.getWpV2Pages = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.after !== undefined && opts.after !== null) {
                            uri.addQuery('after', opts.after.toISOString());
                        }
                        if (opts.author) {
                            opts.author.forEach(function (element) {
                                uri.addQuery('author', element);
                            });
                        }
                        if (opts.authorExclude) {
                            opts.authorExclude.forEach(function (element) {
                                uri.addQuery('author_exclude', element);
                            });
                        }
                        if (opts.before !== undefined && opts.before !== null) {
                            uri.addQuery('before', opts.before.toISOString());
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.menuOrder !== undefined && opts.menuOrder !== null) {
                            uri.addQuery('menu_order', opts.menuOrder);
                        }
                        if (opts.offset !== undefined && opts.offset !== null) {
                            uri.addQuery('offset', opts.offset);
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        if (opts.parent) {
                            opts.parent.forEach(function (element) {
                                uri.addQuery('parent', element);
                            });
                        }
                        if (opts.parentExclude) {
                            opts.parentExclude.forEach(function (element) {
                                uri.addQuery('parent_exclude', element);
                            });
                        }
                        if (opts.slug) {
                            opts.slug.forEach(function (element) {
                                uri.addQuery('slug', element);
                            });
                        }
                        if (opts.status) {
                            opts.status.forEach(function (element) {
                                uri.addQuery('status', element);
                            });
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param context Scope under which the request is made; determines fields present in response.
     * @param password The password for the post if it is password protected.
    */
    DefaultService.prototype.getWpV2PagesById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.password !== undefined && opts.password !== null) {
                            uri.addQuery('password', opts.password);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param parent The ID for the parent of the object.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2PagesByIdAutosaves = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent !== undefined && opts.parent !== null) {
                            uri.addQuery('parent', opts.parent);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param parent
     * @param id
     * @param parent2 The ID for the parent of the object.
     * @param id2 The ID for the object.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2PagesByParentAutosavesById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent2 !== undefined && opts.parent2 !== null) {
                            uri.addQuery('parent', opts.parent2);
                        }
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param parent
     * @param parent2 The ID for the parent of the object.
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param offset Offset the result set by a specific number of items.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by object attribute.
    */
    DefaultService.prototype.getWpV2PagesByParentRevisions = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent2 !== undefined && opts.parent2 !== null) {
                            uri.addQuery('parent', opts.parent2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.offset !== undefined && opts.offset !== null) {
                            uri.addQuery('offset', opts.offset);
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param parent
     * @param id
     * @param parent2 The ID for the parent of the object.
     * @param id2 Unique identifier for the object.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2PagesByParentRevisionsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent2 !== undefined && opts.parent2 !== null) {
                            uri.addQuery('parent', opts.parent2);
                        }
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param after Limit response to posts published after a given ISO8601 compliant date.
     * @param author Limit result set to posts assigned to specific authors.
     * @param authorExclude Ensure result set excludes posts assigned to specific authors.
     * @param before Limit response to posts published before a given ISO8601 compliant date.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param offset Offset the result set by a specific number of items.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by object attribute.
     * @param slug Limit result set to posts with one or more specific slugs.
     * @param status Limit result set to posts assigned one or more statuses.
     * @param categories Limit result set to all items that have the specified term assigned in the categories taxonomy.
     * @param categoriesExclude Limit result set to all items except those that have the specified term assigned in the categories taxonomy.
     * @param tags Limit result set to all items that have the specified term assigned in the tags taxonomy.
     * @param tagsExclude Limit result set to all items except those that have the specified term assigned in the tags taxonomy.
     * @param sticky Limit result set to items that are sticky.
    */
    DefaultService.prototype.getWpV2Posts = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.after !== undefined && opts.after !== null) {
                            uri.addQuery('after', opts.after.toISOString());
                        }
                        if (opts.author) {
                            opts.author.forEach(function (element) {
                                uri.addQuery('author', element);
                            });
                        }
                        if (opts.authorExclude) {
                            opts.authorExclude.forEach(function (element) {
                                uri.addQuery('author_exclude', element);
                            });
                        }
                        if (opts.before !== undefined && opts.before !== null) {
                            uri.addQuery('before', opts.before.toISOString());
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.offset !== undefined && opts.offset !== null) {
                            uri.addQuery('offset', opts.offset);
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        if (opts.slug) {
                            opts.slug.forEach(function (element) {
                                uri.addQuery('slug', element);
                            });
                        }
                        if (opts.status) {
                            opts.status.forEach(function (element) {
                                uri.addQuery('status', element);
                            });
                        }
                        if (opts.categories) {
                            opts.categories.forEach(function (element) {
                                uri.addQuery('categories', element);
                            });
                        }
                        if (opts.categoriesExclude) {
                            opts.categoriesExclude.forEach(function (element) {
                                uri.addQuery('categories_exclude', element);
                            });
                        }
                        if (opts.tags) {
                            opts.tags.forEach(function (element) {
                                uri.addQuery('tags', element);
                            });
                        }
                        if (opts.tagsExclude) {
                            opts.tagsExclude.forEach(function (element) {
                                uri.addQuery('tags_exclude', element);
                            });
                        }
                        if (opts.sticky !== undefined && opts.sticky !== null) {
                            uri.addQuery('sticky', opts.sticky);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the object.
     * @param context Scope under which the request is made; determines fields present in response.
     * @param password The password for the post if it is password protected.
    */
    DefaultService.prototype.getWpV2PostsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.password !== undefined && opts.password !== null) {
                            uri.addQuery('password', opts.password);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param parent The ID for the parent of the object.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2PostsByIdAutosaves = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent !== undefined && opts.parent !== null) {
                            uri.addQuery('parent', opts.parent);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param parent
     * @param id
     * @param parent2 The ID for the parent of the object.
     * @param id2 The ID for the object.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2PostsByParentAutosavesById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent2 !== undefined && opts.parent2 !== null) {
                            uri.addQuery('parent', opts.parent2);
                        }
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param parent
     * @param parent2 The ID for the parent of the object.
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param offset Offset the result set by a specific number of items.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by object attribute.
    */
    DefaultService.prototype.getWpV2PostsByParentRevisions = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent2 !== undefined && opts.parent2 !== null) {
                            uri.addQuery('parent', opts.parent2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.offset !== undefined && opts.offset !== null) {
                            uri.addQuery('offset', opts.offset);
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param parent
     * @param id
     * @param parent2 The ID for the parent of the object.
     * @param id2 Unique identifier for the object.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2PostsByParentRevisionsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.parent2 !== undefined && opts.parent2 !== null) {
                            uri.addQuery('parent', opts.parent2);
                        }
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param type Limit results to items of an object type.
     * @param subtype Limit results to items of one or more object subtypes.
    */
    DefaultService.prototype.getWpV2Search = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.type !== undefined && opts.type !== null) {
                            uri.addQuery('type', opts.type);
                        }
                        if (opts.subtype) {
                            opts.subtype.forEach(function (element) {
                                uri.addQuery('subtype', element);
                            });
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
    */
    DefaultService.prototype.getWpV2Settings = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2Statuses = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param status
     * @param status2 An alphanumeric identifier for the status.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2StatusesByStatus = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.status2 !== undefined && opts.status2 !== null) {
                            uri.addQuery('status', opts.status2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param offset Offset the result set by a specific number of items.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by term attribute.
     * @param hideEmpty Whether to hide terms not assigned to any posts.
     * @param post Limit result set to terms assigned to a specific post.
     * @param slug Limit result set to terms with one or more specific slugs.
    */
    DefaultService.prototype.getWpV2Tags = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.offset !== undefined && opts.offset !== null) {
                            uri.addQuery('offset', opts.offset);
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        if (opts.hideEmpty !== undefined && opts.hideEmpty !== null) {
                            uri.addQuery('hide_empty', opts.hideEmpty);
                        }
                        if (opts.post !== undefined && opts.post !== null) {
                            uri.addQuery('post', opts.post);
                        }
                        if (opts.slug) {
                            opts.slug.forEach(function (element) {
                                uri.addQuery('slug', element);
                            });
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the term.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2TagsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param type Limit results to taxonomies associated with a specific post type.
    */
    DefaultService.prototype.getWpV2Taxonomies = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.type !== undefined && opts.type !== null) {
                            uri.addQuery('type', opts.type);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param taxonomy
     * @param taxonomy2 An alphanumeric identifier for the taxonomy.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2TaxonomiesByTaxonomy = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.taxonomy2 !== undefined && opts.taxonomy2 !== null) {
                            uri.addQuery('taxonomy', opts.taxonomy2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param status Limit result set to themes assigned one or more statuses.
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
    */
    DefaultService.prototype.getWpV2Themes = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.status) {
                            opts.status.forEach(function (element) {
                                uri.addQuery('status', element);
                            });
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2Types = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param type
     * @param type2 An alphanumeric identifier for the post type.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2TypesByType = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.type2 !== undefined && opts.type2 !== null) {
                            uri.addQuery('type', opts.type2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
     * @param page Current page of the collection.
     * @param perPage Maximum number of items to be returned in result set.
     * @param search Limit results to those matching a string.
     * @param exclude Ensure result set excludes specific IDs.
     * @param include Limit result set to specific IDs.
     * @param offset Offset the result set by a specific number of items.
     * @param order Order sort attribute ascending or descending.
     * @param orderby Sort collection by object attribute.
     * @param slug Limit result set to users with one or more specific slugs.
     * @param roles Limit result set to users matching at least one specific role provided. Accepts csv list or single role.
     * @param who Limit result set to users who are considered authors.
    */
    DefaultService.prototype.getWpV2Users = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        if (opts.page !== undefined && opts.page !== null) {
                            uri.addQuery('page', opts.page);
                        }
                        if (opts.perPage !== undefined && opts.perPage !== null) {
                            uri.addQuery('per_page', opts.perPage);
                        }
                        if (opts.search !== undefined && opts.search !== null) {
                            uri.addQuery('search', opts.search);
                        }
                        if (opts.exclude) {
                            opts.exclude.forEach(function (element) {
                                uri.addQuery('exclude', element);
                            });
                        }
                        if (opts.include) {
                            opts.include.forEach(function (element) {
                                uri.addQuery('include', element);
                            });
                        }
                        if (opts.offset !== undefined && opts.offset !== null) {
                            uri.addQuery('offset', opts.offset);
                        }
                        if (opts.order !== undefined && opts.order !== null) {
                            uri.addQuery('order', opts.order);
                        }
                        if (opts.orderby !== undefined && opts.orderby !== null) {
                            uri.addQuery('orderby', opts.orderby);
                        }
                        if (opts.slug) {
                            opts.slug.forEach(function (element) {
                                uri.addQuery('slug', element);
                            });
                        }
                        if (opts.roles) {
                            opts.roles.forEach(function (element) {
                                uri.addQuery('roles', element);
                            });
                        }
                        if (opts.who !== undefined && opts.who !== null) {
                            uri.addQuery('who', opts.who);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param id2 Unique identifier for the user.
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2UsersById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.id2 !== undefined && opts.id2 !== null) {
                            uri.addQuery('id', opts.id2);
                        }
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param context Scope under which the request is made; determines fields present in response.
    */
    DefaultService.prototype.getWpV2UsersMe = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        if (opts.context !== undefined && opts.context !== null) {
                            uri.addQuery('context', opts.context);
                        }
                        options = {
                            method: "get",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param password
     * @param title
     * @param content
     * @param template
    */
    DefaultService.prototype.postWpV2Blocks = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id2
     * @param id
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param password
     * @param title
     * @param content
     * @param template
    */
    DefaultService.prototype.postWpV2BlocksById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param parent
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param password
     * @param title
     * @param content
     * @param template
    */
    DefaultService.prototype.postWpV2BlocksByIdAutosaves = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param description
     * @param name
     * @param slug
     * @param parent
     * @param meta
    */
    DefaultService.prototype.postWpV2Categories = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id2
     * @param id
     * @param description
     * @param name
     * @param slug
     * @param parent
     * @param meta
    */
    DefaultService.prototype.postWpV2CategoriesById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param author
     * @param authorEmail
     * @param authorIp
     * @param authorName
     * @param authorUrl
     * @param authorUserAgent
     * @param content
     * @param date
     * @param dateGmt
     * @param parent
     * @param post
     * @param status
     * @param meta
    */
    DefaultService.prototype.postWpV2Comments = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id2
     * @param id
     * @param author
     * @param authorEmail
     * @param authorIp
     * @param authorName
     * @param authorUrl
     * @param authorUserAgent
     * @param content
     * @param date
     * @param dateGmt
     * @param parent
     * @param post
     * @param status
     * @param meta
    */
    DefaultService.prototype.postWpV2CommentsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param title
     * @param author
     * @param commentStatus
     * @param pingStatus
     * @param meta
     * @param template
     * @param altText
     * @param caption
     * @param description
     * @param post
    */
    DefaultService.prototype.postWpV2Media = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id2
     * @param id
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param title
     * @param author
     * @param commentStatus
     * @param pingStatus
     * @param meta
     * @param template
     * @param altText
     * @param caption
     * @param description
     * @param post
    */
    DefaultService.prototype.postWpV2MediaById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param password
     * @param parent
     * @param title
     * @param content
     * @param author
     * @param excerpt
     * @param featuredMedia
     * @param commentStatus
     * @param pingStatus
     * @param menuOrder
     * @param meta
     * @param template
    */
    DefaultService.prototype.postWpV2Pages = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id2
     * @param id
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param password
     * @param parent
     * @param title
     * @param content
     * @param author
     * @param excerpt
     * @param featuredMedia
     * @param commentStatus
     * @param pingStatus
     * @param menuOrder
     * @param meta
     * @param template
    */
    DefaultService.prototype.postWpV2PagesById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param parent
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param password
     * @param title
     * @param content
     * @param author
     * @param excerpt
     * @param featuredMedia
     * @param commentStatus
     * @param pingStatus
     * @param menuOrder
     * @param meta
     * @param template
    */
    DefaultService.prototype.postWpV2PagesByIdAutosaves = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param password
     * @param title
     * @param content
     * @param author
     * @param excerpt
     * @param featuredMedia
     * @param commentStatus
     * @param pingStatus
     * @param format
     * @param meta
     * @param sticky
     * @param template
     * @param categories
     * @param tags
    */
    DefaultService.prototype.postWpV2Posts = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id2
     * @param id
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param password
     * @param title
     * @param content
     * @param author
     * @param excerpt
     * @param featuredMedia
     * @param commentStatus
     * @param pingStatus
     * @param format
     * @param meta
     * @param sticky
     * @param template
     * @param categories
     * @param tags
    */
    DefaultService.prototype.postWpV2PostsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id
     * @param parent
     * @param date
     * @param dateGmt
     * @param slug
     * @param status
     * @param password
     * @param title
     * @param content
     * @param author
     * @param excerpt
     * @param featuredMedia
     * @param commentStatus
     * @param pingStatus
     * @param format
     * @param meta
     * @param sticky
     * @param template
     * @param categories
     * @param tags
    */
    DefaultService.prototype.postWpV2PostsByIdAutosaves = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param title
     * @param description
     * @param url
     * @param email
     * @param timezone
     * @param dateFormat
     * @param timeFormat
     * @param startOfWeek
     * @param language
     * @param useSmilies
     * @param defaultCategory
     * @param defaultPostFormat
     * @param postsPerPage
     * @param defaultPingStatus
     * @param defaultCommentStatus
    */
    DefaultService.prototype.postWpV2Settings = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param description
     * @param name
     * @param slug
     * @param meta
    */
    DefaultService.prototype.postWpV2Tags = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id2
     * @param id
     * @param description
     * @param name
     * @param slug
     * @param meta
    */
    DefaultService.prototype.postWpV2TagsById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param username
     * @param name
     * @param firstName
     * @param lastName
     * @param email
     * @param url
     * @param description
     * @param locale
     * @param nickname
     * @param slug
     * @param roles
     * @param password
     * @param meta
    */
    DefaultService.prototype.postWpV2Users = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param id2
     * @param id
     * @param username
     * @param name
     * @param firstName
     * @param lastName
     * @param email
     * @param url
     * @param description
     * @param locale
     * @param nickname
     * @param slug
     * @param roles
     * @param password
     * @param meta
    */
    DefaultService.prototype.postWpV2UsersById = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    /**
     *
     * @param username
     * @param name
     * @param firstName
     * @param lastName
     * @param email
     * @param url
     * @param description
     * @param locale
     * @param nickname
     * @param slug
     * @param roles
     * @param password
     * @param meta
    */
    DefaultService.prototype.postWpV2UsersMe = function (opts) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, options, response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!opts) {
                            opts = {};
                        }
                        uri = new URI("" + this.basePath);
                        options = {
                            method: "post",
                            headers: {
                                "Content-Type": "application/json",
                                "Authorization": "Bearer " + (this.rptToken ? this.rptToken : this.token)
                            }
                        };
                        return [4 /*yield*/, fetch(uri.toString(), options)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, api_1.ApiUtils.handleResponse(response)];
                }
            });
        });
    };
    return DefaultService;
}());
exports.DefaultService = DefaultService;
