/**
 * localhost:1234
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { AttachmentCaption } from './attachmentCaption';
import { AttachmentDescription } from './attachmentDescription';
import { PostGuid } from './postGuid';
import { PostTitle } from './postTitle';
export interface Attachment {
    /**
     * The date the object was published, in the site's timezone.
     */
    date?: Date;
    /**
     * The date the object was published, as GMT.
     */
    date_gmt?: Date;
    guid?: PostGuid;
    /**
     * Unique identifier for the object.
     */
    id?: number;
    /**
     * URL to the object.
     */
    link?: string;
    /**
     * The date the object was last modified, in the site's timezone.
     */
    modified?: Date;
    /**
     * The date the object was last modified, as GMT.
     */
    modified_gmt?: Date;
    /**
     * An alphanumeric identifier for the object unique to its type.
     */
    slug?: string;
    /**
     * A named status for the object.
     */
    status?: Attachment.StatusEnum;
    /**
     * Type of Post for the object.
     */
    type?: string;
    /**
     * Permalink template for the object.
     */
    permalink_template?: string;
    /**
     * Slug automatically generated from the object title.
     */
    generated_slug?: string;
    title?: PostTitle;
    /**
     * The ID for the author of the object.
     */
    author?: number;
    /**
     * Whether or not comments are open on the object.
     */
    comment_status?: Attachment.CommentStatusEnum;
    /**
     * Whether or not the object can be pinged.
     */
    ping_status?: Attachment.PingStatusEnum;
    /**
     * Meta fields.
     */
    meta?: any;
    /**
     * The theme file to use to display the object.
     */
    template?: string;
    /**
     * Alternative text to display when attachment is not displayed.
     */
    alt_text?: string;
    caption?: AttachmentCaption;
    description?: AttachmentDescription;
    /**
     * Attachment type.
     */
    media_type?: Attachment.MediaTypeEnum;
    /**
     * The attachment MIME type.
     */
    mime_type?: string;
    /**
     * Details about the media file, specific to its type.
     */
    media_details?: any;
    /**
     * The ID for the associated post of the attachment.
     */
    post?: number;
    /**
     * URL to the original attachment file.
     */
    source_url?: string;
}
export interface AttachmentOpt {
    /**
     * The date the object was published, in the site's timezone.
     */
    date?: Date;
    /**
     * The date the object was published, as GMT.
     */
    date_gmt?: Date;
    guid?: PostGuid;
    /**
     * Unique identifier for the object.
     */
    id?: number;
    /**
     * URL to the object.
     */
    link?: string;
    /**
     * The date the object was last modified, in the site's timezone.
     */
    modified?: Date;
    /**
     * The date the object was last modified, as GMT.
     */
    modified_gmt?: Date;
    /**
     * An alphanumeric identifier for the object unique to its type.
     */
    slug?: string;
    /**
     * A named status for the object.
     */
    status?: Attachment.StatusEnum;
    /**
     * Type of Post for the object.
     */
    type?: string;
    /**
     * Permalink template for the object.
     */
    permalink_template?: string;
    /**
     * Slug automatically generated from the object title.
     */
    generated_slug?: string;
    title?: PostTitle;
    /**
     * The ID for the author of the object.
     */
    author?: number;
    /**
     * Whether or not comments are open on the object.
     */
    comment_status?: Attachment.CommentStatusEnum;
    /**
     * Whether or not the object can be pinged.
     */
    ping_status?: Attachment.PingStatusEnum;
    /**
     * Meta fields.
     */
    meta?: any;
    /**
     * The theme file to use to display the object.
     */
    template?: string;
    /**
     * Alternative text to display when attachment is not displayed.
     */
    alt_text?: string;
    caption?: AttachmentCaption;
    description?: AttachmentDescription;
    /**
     * Attachment type.
     */
    media_type?: Attachment.MediaTypeEnum;
    /**
     * The attachment MIME type.
     */
    mime_type?: string;
    /**
     * Details about the media file, specific to its type.
     */
    media_details?: any;
    /**
     * The ID for the associated post of the attachment.
     */
    post?: number;
    /**
     * URL to the original attachment file.
     */
    source_url?: string;
}
export declare namespace Attachment {
    type StatusEnum = 'publish' | 'future' | 'draft' | 'pending' | 'private';
    const StatusEnum: {
        Publish: StatusEnum;
        Future: StatusEnum;
        Draft: StatusEnum;
        Pending: StatusEnum;
        Private: StatusEnum;
    };
    type CommentStatusEnum = 'open' | 'closed';
    const CommentStatusEnum: {
        Open: "closed" | "open";
        Closed: "closed" | "open";
    };
    type PingStatusEnum = 'open' | 'closed';
    const PingStatusEnum: {
        Open: "closed" | "open";
        Closed: "closed" | "open";
    };
    type MediaTypeEnum = 'image' | 'file';
    const MediaTypeEnum: {
        Image: MediaTypeEnum;
        File: MediaTypeEnum;
    };
}
